]> Savannah Git Hosting - gnulib.git/commitdiff
execl: Add tests.
authorBruno Haible <bruno@clisp.org>
Sat, 26 Dec 2020 13:37:54 +0000 (14:37 +0100)
committerBruno Haible <bruno@clisp.org>
Sat, 26 Dec 2020 13:37:54 +0000 (14:37 +0100)
* tests/test-execl-main.c: New file.
* tests/test-execl.sh: New file.
* modules/execl-tests: New file.

ChangeLog
modules/execl-tests [new file with mode: 0644]
tests/test-execl-main.c [new file with mode: 0644]
tests/test-execl.sh [new file with mode: 0755]

index 5b8e5538a61b05c62fcfae17b9ecc9aba9e404c0..7f5c99b9021b2f83d6ae302225ee0f2701abfabe 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,10 @@
 2020-12-26  Bruno Haible  <bruno@clisp.org>
 
+       execl: Add tests.
+       * tests/test-execl-main.c: New file.
+       * tests/test-execl.sh: New file.
+       * modules/execl-tests: New file.
+
        execl: New module.
        * lib/execl.c: New file.
        * m4/execl.m4: New file.
diff --git a/modules/execl-tests b/modules/execl-tests
new file mode 100644 (file)
index 0000000..a7c56f5
--- /dev/null
@@ -0,0 +1,11 @@
+Files:
+tests/test-execl.sh
+tests/test-execl-main.c
+tests/test-exec-child.c
+tests/signature.h
+
+Depends-on:
+
+Makefile.am:
+TESTS += test-execl.sh
+check_PROGRAMS += test-execl-main test-exec-child
diff --git a/tests/test-execl-main.c b/tests/test-execl-main.c
new file mode 100644 (file)
index 0000000..a16cefa
--- /dev/null
@@ -0,0 +1,49 @@
+/* Test of execl().
+   Copyright (C) 2020 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, see <https://www.gnu.org/licenses/>.  */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2020.  */
+
+#include <config.h>
+
+/* Specification.  */
+#include <unistd.h>
+
+#include "signature.h"
+SIGNATURE_CHECK (execl, int, (const char *, const char *, ...));
+
+#include <stdio.h>
+
+int
+main ()
+{
+  const char *progname = "./test-exec-child";
+  execl (progname,
+         progname,
+         "abc def",
+         "abc\"def\"ghi",
+         "xyz\"",
+         "abc\\def\\ghi",
+         "xyz\\",
+         "???",
+         "***",
+         "",
+         "foo",
+         "",
+         NULL);
+
+  perror ("execl");
+  return 1;
+}
diff --git a/tests/test-execl.sh b/tests/test-execl.sh
new file mode 100755 (executable)
index 0000000..285059d
--- /dev/null
@@ -0,0 +1,47 @@
+#!/bin/sh
+
+# Test of execl().
+#
+# Copyright (C) 2020 Free Software Foundation, Inc.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <https://www.gnu.org/licenses/>.  */
+#
+# Written by Bruno Haible <bruno@clisp.org>, 2020.
+
+${CHECKER} ./test-execl-main${EXEEXT} > test-execl.tmp
+result=$?
+test $result = 49 || exit 1
+LC_ALL=C tr -d '\r' < test-execl.tmp > test-execl.out || exit 1
+
+cat > test-execl.ok <<\EOF
+argc = 11
+argv[1] = |abc def|
+argv[2] = |abc"def"ghi|
+argv[3] = |xyz"|
+argv[4] = |abc\def\ghi|
+argv[5] = |xyz\|
+argv[6] = |???|
+argv[7] = |***|
+argv[8] = ||
+argv[9] = |foo|
+argv[10] = ||
+EOF
+
+: ${DIFF=diff}
+${DIFF} test-execl.ok test-execl.out
+result=$?
+
+rm -f test-execl.tmp test-execl.out test-execl.ok
+
+exit $result